
; fasm example of writing Win32 GUI application

format PE GUI
entry start

macro align value { rb (value-1) - (rva $ + value-1) mod value }

include 'win32.inc'

section '.data' data readable writeable

  newhwnd dd 0				; handle of window
  hinstance dd 0			; handle of module

  msg MSGSTRUCT
  wc WNDCLASS

  _title db 'flat assembler Win32 application',0
  _class db 'FASMWIN32',0

  _caption db 'Win32 assembly program',0
  _message db 'Left mouse button pressed.',0

section '.code' code readable executable

  start:

	push	0
	call	[GetModuleHandle]
	mov	[hinstance],eax

	push	17			; resource id
	push	eax			; module handle
	call	[LoadIcon]
	mov	[wc.clsHIcon],eax

	push	IDC_ARROW
	push	0
	call	[LoadCursor]
	mov	[wc.clsHCursor],eax

	mov	[wc.clsStyle],CS_HREDRAW+CS_VREDRAW+CS_GLOBALCLASS
	mov	[wc.clsLpfnWndProc],WindowProc
	mov	[wc.clsCbClsExtra],0
	mov	[wc.clsCbWndExtra],0
	mov	eax,[hinstance]
	mov	[wc.clsHInstance],eax
	mov	[wc.clsHbrBackground],COLOR_BTNSHADOW
	mov	[wc.clsLpszMenuName],0
	mov	[wc.clsLpszClassName],_class
	push	wc
	call	[RegisterClass]

	push	0
	push	[hinstance]		; handle
	push	0			; menu
	push	0			; parent hwnd
	push	200			; height
	push	320			; width
	push	100			; y
	push	100			; x
	push	WS_DLGFRAME+WS_SYSMENU	; style
	push	_title			; title string
	push	_class			; class name
	push	0			; extra style
	call	[CreateWindowEx]
	mov	[newhwnd],eax

	push	SW_SHOWNORMAL
	push	[newhwnd]
	call	[ShowWindow]
	push	[newhwnd]
	call	[UpdateWindow]

  msg_loop:
	push	0
	push	0
	push	0
	push	msg
	call	[GetMessage]
	or	ax,ax
	jz	end_loop
	push	msg
	call	[TranslateMessage]
	push	msg
	call	[DispatchMessage]
	jmp	msg_loop

  end_loop:
	push	[msg.msWPARAM]
	call	[ExitProcess]

include 'stdcall.inc'

  WindowProc:
      params
	dword	hwnd
	dword	wmsg
	dword	wparam
	dword	lparam
      proc
	push	ebx esi edi		; Win32 needs it to be preserved
	cmp	[wmsg],WM_DESTROY
	je	wmdestroy
	cmp	[wmsg],WM_LBUTTONDOWN
	je	wmlbuttondown
	cmp	[wmsg],WM_RBUTTONDOWN
	je	wmrbuttondown
      defwindowproc:
	push	[lparam]
	push	[wparam]
	push	[wmsg]
	push	[hwnd]
	call	[DefWindowProc]
	jmp	finish
      wmdestroy:
	push	0
	call	[PostQuitMessage]
	xor	eax,eax
	jmp	finish
      wmlbuttondown:
	push	MB_OK + MB_ICONASTERISK
	push	_caption
	push	_message
	push	[hwnd]
	call	[MessageBox]
	jmp	finish
      wmrbuttondown:
	push	MB_OK
	call	[MessageBeep]
      finish:
	pop	edi esi ebx
	retp

include 'idata.inc'
include 'resource.inc'
